import * as THREE from 'three';
import { UseStore } from 'zustand';
import type { BaseInstance, LocalState } from '@react-three/fiber/src/core/renderer';
import type { RootState } from '@react-three/fiber/src/core/store';
export declare type MockUseStoreState = UseStore<RootState>;
export interface MockInstance extends Omit<BaseInstance, '__r3f'> {
    __r3f: Omit<LocalState, 'root' | 'objects' | 'parent'> & {
        root: MockUseStoreState;
        objects: MockSceneChild[];
        parent: MockInstance;
    };
}
export interface MockSceneChild extends Omit<MockInstance, 'children'> {
    children: MockSceneChild[];
}
export interface MockScene extends Omit<THREE.Scene, 'children'>, Pick<MockInstance, '__r3f'> {
    children: MockSceneChild[];
}
export declare type CreateCanvasParameters = {
    beforeReturn?: (canvas: HTMLCanvasElement) => void;
    width?: number;
    height?: number;
};
export interface Obj {
    [key: string]: any;
}
export declare type MockEventData = {
    [key: string]: any;
};
export interface TestInstanceChildOpts {
    exhaustive: boolean;
}
